﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=7.3
@EndOfDesignText@
#Region Module Attributes
	#FullScreen: True
	#IncludeTitle: False
#End Region

'-----------------------------------------------------------
'						Activity module
'				   P E D I D O   V E N D A
'-----------------------------------------------------------
Sub Process_Globals
End Sub

Sub Globals
	Dim btnAdicionarMercadoria As Button
	Dim btnPesquisarMercadoria As Button
	Dim btnRemoverMercadoria 	As Button
	
	Dim cbPlanos 					As Spinner
	Dim edtCodigo 					As EditText
	Dim edtQuantidade 			As EditText
	
	Dim lblCliente 				As Label
	Dim lblClienteNome 			As Label
	Dim lblCodigoMercadoria 	As Label
	Dim lblDescricaoMercadoria As Label
	Dim lblPlano 					As Label
	Dim lblQuantidade 			As Label
	Dim lblVendedor 				As Label
	Dim lblVendedorNome 			As Label
	
	Dim lvProdutos 				As ListView
	Dim lblDataAtual 				As Label
	
	Dim edtPreco 					As EditText
	Dim panelAcoes 				As Panel
	
	Dim btnRealizarPedido 		As Button
	Dim btnTotalPedidoValor 	As Button
	Dim btnConsultarVendas 		As Button
	Dim btnNovaVenda 				As Button
	Dim btnQuantidadeMais 		As Button
	Dim btnQuantidadeMenos 		As Button
	Dim btnHistoricoVendas 		As Button
	Dim btnCancelar 				As Button
	Dim btnConfirmar 				As Button
	Dim editNumero 				As EditText
	
	Dim pedindo_preco			As Boolean
	Dim pedindo_quantidade      As Boolean
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("frmPedidoVenda")
	CarregaPlanos

	edtCodigo.text 				 = ""
	edtQuantidade.text			 = ""
	edtPreco.Text				    = ""
	lblDescricaoMercadoria.Text = ""
	pedindo_preco               = False
	pedindo_quantidade          = False
End Sub


Sub Activity_Resume
	Dim Ph As Phone
	lblDataAtual.Text 	 		 = Geral.venda_atual_data
	lblVendedorNome.Text 		 = "  " & Geral.Vendedor_atual_nome
	lblClienteNome.Text  		 = "  " & Geral.Copy(Geral.Cliente_atual_nome, 1, 20)

	edtCodigo.text 				 = ""
	edtQuantidade.text			 = ""
	edtPreco.Text				    = ""
	lblDescricaoMercadoria.Text = ""
	
	CarregaPlanos
	AtualizaEstado
	
	If (Geral.Produto_codigo_atual <> "") Then
		
		edtCodigo.text     = Geral.Produto_codigo_atual
		edtQuantidade.text = Geral.Produto_qtde_atual
		
		If (pedindo_quantidade = True) Then
			If (Geral.transporte_resposta) Then
				edtQuantidade.text = Geral.transporte_valor
				Geral.Produto_qtde_atual = edtQuantidade.text
			End If
			pedindo_quantidade = False
		End If
		
		edtPreco.Text = Geral.Produto_preco_atual
		
		If (pedindo_preco = True)	Then
			If (Geral.transporte_resposta) Then
				edtPreco.Text = Geral.transporte_valor
				Geral.Produto_preco_atual = edtPreco.text
			End If
			pedindo_preco = False
		End If
		lblDescricaoMercadoria.Text = Geral.Produto_descricao_atual
	End If
	Ph.HideKeyboard(Activity)
	
	AjustaControles
End Sub


Sub Activity_Pause (UserClosed As Boolean)
	'Activity.Finish
End Sub


Sub lvProdutos_ItemClick (Position As Int, Value As Object)
	edtCodigo.Text 			= Geral.lstVenda_produtos_codigo.Get(Position)
	edtQuantidade.text		= Geral.lstVenda_produtos_qtde.Get(Position)
	edtPreco.Text 				= Geral.lstVenda_produtos_preco.Get(Position)
	lblDescricaoMercadoria.Text = " " & Geral.lstVenda_produtos_descricao.Get(Position)
End Sub


Sub cbPlanos_ItemClick (Position As Int, Value As Object)
	Geral.Plano_atual_codigo = Geral.Copy(cbPlanos.GetItem(Position), 1, 4)
	If (Geral.Plano_atual_codigo = "0000") Then 
		Geral.Plano_atual_codigo      = ""
		Geral.Plano_atual_percentual  = 0
		AtualizaEstado
		Return
	End If
	CarregaPlanos
	AtualizaEstado
End Sub

Sub AtualizaEstado
	RecalculaPreco
	CarregaProdutos
	TotalizaPedido
End Sub

Sub btnPesquisarMercadoria_Click
	Geral.Produto_codigo_atual = "" 
	StartActivity(actSelecionaProduto)
End Sub

Sub btnRemoverMercadoria_Click
	Dim index As Int
	If (edtCodigo.Text = "") Then
		Geral.Erro("Você deve clicar em uma mercadoria primeiro!")
		Return
	End If
	index = Geral.lstVenda_produtos_codigo.IndexOf(edtCodigo.Text)
	If (index <> -1) Then 
		Geral.lstVenda_produtos_codigo.RemoveAt(index)
		Geral.lstVenda_produtos_descricao.RemoveAt(index)
		Geral.lstVenda_produtos_preco.RemoveAt(index)
		Geral.lstVenda_produtos_preco_original.RemoveAt(index)
		Geral.lstVenda_produtos_qtde.RemoveAt(index)
		
		edtCodigo.Text 				 = ""
		edtQuantidade.Text 			 = ""
		edtPreco.Text 					 = ""
		lblDescricaoMercadoria.text = ""
		AtualizaEstado
		Return
	End If	
End Sub

Sub btnAdicionarMercadoria_Click
	Dim Achou As Boolean
	
	If (edtCodigo.Text = "") Or (edtQuantidade.Text = "") Then
		Geral.Erro("Você deve preencher o CÓDIGO e a QUANTIDADE do produto!")
		Return
	End If
	
	Achou = False
	For i = 0 To Geral.lstVenda_produtos_codigo.Size - 1
		If ((Geral.lstVenda_produtos_codigo.Get(i) * 1)= (edtCodigo.Text * 1)) Then 
			
			Geral.lstVenda_produtos_codigo.Set(i, edtCodigo.Text)
			Geral.lstVenda_produtos_descricao.Set(i, lblDescricaoMercadoria.Text)
			Geral.lstVenda_produtos_qtde.Set(i, edtQuantidade.Text)
			Geral.lstVenda_produtos_preco.Set(i, edtPreco.Text)
			Geral.lstVenda_produtos_preco_original.Set(i, edtPreco.Text)
			Achou = True				
		End If
	Next
	
	If Not(Achou) Then
		Geral.lstVenda_produtos_codigo.Add(edtCodigo.Text)
		Geral.lstVenda_produtos_descricao.Add(lblDescricaoMercadoria.Text)
		Geral.lstVenda_produtos_qtde.Add(edtQuantidade.Text)
		Geral.lstVenda_produtos_preco.Add(edtPreco.Text)
		Geral.lstVenda_produtos_preco_original.Add(edtPreco.Text)
	End If
	
	AtualizaEstado	
	
	edtCodigo.Text 				  = ""
	edtQuantidade.Text 			  = ""
	edtPreco.Text 				     = ""
	lblDescricaoMercadoria.text  = ""
	
	Geral.Produto_codigo_atual   = ""
	
End Sub

Sub CarregaPlanos

	Dim linha 	   	As String
	Dim linha_combo 	As String
	Dim Codigo     	As String
	Dim Descricao 		As String

	'--------------------------------------------------------------	
	' Carrega os Planos no Combo
	'--------------------------------------------------------------
	cbPlanos.Clear
	cbPlanos.Add("0000-Selecione")
	For i = 0 To Geral.lstPlanos.Size - 1
		linha = Geral.lstPlanos.Get(i)
		If (linha.StartsWith(";")) Then 
			Continue
		End If
		
		Codigo     = Geral.Copy(linha, 1, 4)
		Descricao  = Geral.Copy(linha, 6, 40)
		cbPlanos.Add(Codigo & "-" & Descricao)
	Next
	'--------------------------------------------------------------
	' Coloca o Combo na posição correta
	'--------------------------------------------------------------
	If (Geral.Plano_atual_codigo <> "") Then 
		For i = 0 To Geral.lstPlanos.Size - 1
			linha = Geral.lstPlanos.Get(i)
			If Geral.Copy(linha, 1, 4) = Geral.Plano_atual_codigo  Then 
				For j = 0 To cbPlanos.Size - 1
					linha_combo = cbPlanos.GetItem(j)
					If Geral.Plano_atual_codigo = Geral.Copy(linha_combo, 1, 4)  Then 
						cbPlanos.SelectedIndex = j
					End If
				Next
				Geral.Plano_atual_codigo     = Geral.Copy(linha, 1, 4)
				Geral.Plano_atual_percentual = Geral.Copy(linha, 47, 7)
				Geral.Plano_atual_descricao  = Geral.Copy(linha, 6, 40)
				RecalculaPreco
				Exit
			End If
		Next
	End If
End Sub

Sub RecalculaPreco
	Dim Preco_original	As Float
	Dim Preco_calc 		As Float
	'Geral.Erro("Plano P:" & Geral.Plano_atual_percentual)
	For i = 0 To Geral.lstVenda_produtos_codigo.Size - 1
		Preco_original  = Geral.lstVenda_produtos_preco_original.Get(i)
		Preco_calc      = Preco_original + Round2(Preco_original * Geral.Plano_atual_percentual / 100, 2)

		Geral.lstVenda_produtos_preco.Set(i, Preco_calc) 
	Next
End Sub

Sub btnRealizarPedido_Click
	If lvProdutos.Size = 0 Then 
		Geral.Erro("Você deve inserir os produtos antes de realizar o pedido!")
		Return
	End If
	
	If Geral.Plano_atual_codigo = "" Then
		Geral.Erro("Você deve selecionar um PLANO antes de fechar o pedido!")
		Return
	End If
	
	If Geral.Cliente_atual_codigo = "" Then
		Geral.Erro("Você deve selecionar um CLIENTE antes de fechar o pedido!")
		Return
	End If
	
	If Geral.Vendedor_atual_codigo = "" Then 
		Geral.Erro("Você deve selecionar um VENDEDOR antes de fechar o pedido!")
		Return
	End If
	
	If (Geral.EMPRESA_DEFAULT = "") Then 
		StartActivity(actSelecionaEmpresa)
	Else
		If Geral.AvisoSimNao("Fechar o pedido na empresa " & Geral.Empresa_atual_razao & "?") Then 
			Geral.Empresa_atual_codigo = Geral.EMPRESA_DEFAULT
			Geral.GravaVenda()
			Geral.NovaVenda()
			StartActivity(actSelecionaCliente)
		End If
	End If
End Sub

Sub CarregaProdutos
	Dim Linha, Linha2 							  As String
	Dim Codigo, Descricao, Quantidade, preco As String
	lvProdutos.Clear()
	
	For i = 0 To Geral.lstVenda_produtos_codigo.Size - 1
		Codigo 		= Geral.lstVenda_produtos_codigo.Get(i)	
		Descricao 	= Geral.lstVenda_produtos_descricao.Get(i)
		
		If (Descricao.Length > 22) Then 
			Descricao = Geral.Copy(Descricao, 1, 25) & "..."
		End If
		
		Descricao   = Geral.PadSpace(Descricao, 25)
		Quantidade  = Geral.PadLeft(Geral.FormataQuantidade(Geral.lstVenda_produtos_qtde.Get(i)), 10) 
		preco       = Geral.PadLeft(Geral.FormataNumero(Geral.lstVenda_produtos_preco.Get(i)), 10)

		Linha  = Codigo & " " & Descricao 
		Linha2 = Quantidade & " " & preco
		lvProdutos.AddTwoLines(Linha, Linha2)
	Next
	
End Sub

Sub TotalizaPedido
	Dim Total As Float
	Total = 0
	For i = 0 To Geral.lstVenda_produtos_codigo.Size - 1
		Total = Total + (Geral.lstVenda_produtos_qtde.Get(i) * 1) * (Geral.lstVenda_produtos_preco.Get(i) * 1) 
	Next
	btnTotalPedidoValor.Text = Geral.FormataNumero(Total)
End Sub 

Sub btnNovaVenda_Click
	If Geral.lstVenda_produtos_codigo.Size > 0 Then 
		If Geral.AvisoSimNao("Abandonar pedido atual?") Then 
			Geral.NovaVenda
		Else
			Return
		End If
	Else
		Geral.NovaVenda
	End If
	StartActivity(actSelecionaCliente)
	AtualizaEstado
End Sub

Sub btnConsultarVendas_Click
	StartActivity(actInformacoesVendas)	
End Sub

Sub btnQuantidadeMenos_Click
	Dim qtde As Float
	If IsNumber(edtQuantidade.Text) Then
		qtde = edtQuantidade.Text * 1
	Else
		qtde = 0
	End If
	If (qtde > 1) Then 
		qtde = qtde - 1
		edtQuantidade.Text = qtde
	End If	
End Sub

Sub btnQuantidadeMais_Click
	Dim qtde As Float
	If IsNumber(edtQuantidade.Text) Then
		qtde = edtQuantidade.Text * 1
	Else
		qtde = 0
	End If
	qtde = qtde + 1
	edtQuantidade.Text = qtde	
End Sub

Sub btnHistoricoVendas_Click
	StartActivity(actHistoricoVendas)	
End Sub

Sub edtQuantidade_FocusChanged (HasFocus As Boolean)
	If (HasFocus) Then
		edtQuantidade.SelectAll
	End If
End Sub

Sub edtPreco_FocusChanged (HasFocus As Boolean)
	If (HasFocus) Then 
		edtPreco.SelectAll
	End If
End Sub

Sub AjustaControles
	Geral.FormataDuasLinhas(lvProdutos)
End Sub
