﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=7.3
@EndOfDesignText@
#Region Module Attributes
	#FullScreen: True
	#IncludeTitle: True
#End Region

'-----------------------------------------------------------
'						Activity module
'						P R O D U T O S
'-----------------------------------------------------------
Sub Process_Globals

End Sub

Sub Globals
	Dim edtPesquisaProduto 	As EditText
	Dim lvProdutos 			As ListView
	Dim lblPesquisaProduto 	As Label
	Dim edtEstoque 			As EditText
	Dim edtPreco 				As EditText
	Dim panelRodape 			As Panel
	
	Dim lstProdutos			As List 	
	Dim lstCodigos				As List
	Dim lstPrecos				As List
	Dim lstDescricoes       As List
	Dim lstEstoques			As List
	
	Dim btnSelecionar 		As Button
	Dim last_index			As Int
	Dim lblProdutoSelecionado As Label
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("frmSelecionaProduto")
	last_index = -1
	
	lstProdutos.Initialize
	lstCodigos.Initialize
	lstPrecos.Initialize
	lstDescricoes.Initialize
	lstEstoques.Initialize
	
	AjustaControles

	CarregaProdutos(edtPesquisaProduto.Text)
End Sub

Sub Activity_Resume
	AjustaControles
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	Dim PH As Phone
	PH.HideKeyboard(Activity)
End Sub

Sub CarregaProdutos(pesquisar As String)

	Dim linha 	 	 As String
	Dim Codigo 	 	 As String
	Dim Preco		 As String
	Dim Estoque     As String
	Dim Descricao	 As String
	
	Dim Campos() As String
	
	If Not(File.Exists(Geral.FILE_PATH, Geral.ARQUIVO_PRODUTOS)) Then 
		Geral.Erro("Arquivo de PRODUTOS não encontrado. Faça a sincronização novamente!")
		StartActivity(Main)
		Return
	End If
	
	lstCodigos.clear
	lstDescricoes.clear
	lstPrecos.clear
	lstEstoques.clear
	
	lstProdutos = File.ReadList(Geral.FILE_PATH, Geral.ARQUIVO_PRODUTOS)
	

	
	ProgressDialogShow("Carregando dados...")
	lvProdutos.Clear
	
	For i = 0 To lstProdutos.Size - 1
		linha = lstProdutos.Get(i)
		
		If linha.StartsWith(";") Then 
			Continue
		End If
		
		' 46354|***AVELA S/CASCA KG                     |0000039.99|+00000.000
		
		If linha.IndexOf("|") <> -1 Then 
			Campos     = Geral.Split("|", linha)
			Codigo 	  = Campos(0)
			Descricao  = Campos(1)
			Preco      = Campos(2)
			Estoque    = Campos(3)
		Else
			Codigo     = Geral.Copy(linha, 1, 5)
			Descricao  = Geral.Copy(linha, 7, 40)
			Preco      = Geral.Copy(linha, 48, 10)
			Estoque    = Geral.Copy(linha, 59, 10)
		End If
		
		lvProdutos.AddSingleLine(Descricao.ToUpperCase)
		
		lstCodigos.Add(Codigo)
		lstDescricoes.Add(Descricao.ToUpperCase)
		lstPrecos.Add(Preco)
		lstEstoques.Add(Estoque)
	Next
	ProgressDialogHide
End Sub

Sub lvProdutos_ItemClick (Position As Int, Value As Object)
	last_index = Position
	
	edtPreco.Text   		      = Geral.FormataNumero(lstPrecos.Get(Position) * 1)
	edtEstoque.Text 		      = Geral.FormataQuantidade(lstEstoques.Get(Position) * 1)
	lblProdutoSelecionado.Text = lstCodigos.Get(Position) & "-" & lstDescricoes.Get(Position)
	
End Sub

Sub edtPesquisaProduto_TextChanged (Old As String, New As String)
	Dim i 	 As Int
	Dim nome  As String
 
	If Not(IsNumber(New)) Then
		For i = 0 To lstDescricoes.Size - 1
			nome = lstDescricoes.Get(i)
			If nome.IndexOf(New.ToUpperCase) <> -1 Then
				lvProdutos.SetSelection(i)
				Exit
			End If
		Next
	Else
		For i = 0 To lstCodigos.Size - 1
			nome = lstCodigos.Get(i)
			If nome.IndexOf(New) <> -1 Then
				lvProdutos.SetSelection(i)
				Exit
			End If
		Next
	End If
	lvProdutos.Invalidate
End Sub

Sub btnSelecionar_Click

	If (last_index = -1) Then 
		Geral.Erro("Você deve selecionar um produto!")
		Return
	End If
	
	Geral.Produto_codigo_atual    = lstCodigos.Get(last_index)
	Geral.Produto_descricao_atual = lstDescricoes.Get(last_index)
	
	Geral.Produto_preco_atual     = Geral.FormataNumero(lstPrecos.Get(last_index))
	Geral.Produto_estoque_atual   = Geral.FormataQuantidade(lstEstoques.Get(last_index))
	
	Activity.Finish
End Sub

Sub AjustaControles
	lvProdutos.SingleLineLayout.Label.TextSize = 18
	lvProdutos.SingleLineLayout.ItemHeight     = 4dip * 18

End Sub
