﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=7.3
@EndOfDesignText@
#Region Module Attributes
	#FullScreen: True
	#IncludeTitle: True
#End Region

Sub Process_Globals
	Dim mFTP 					As FTP
	Dim mFTPTotalDownloaded As Int
	Dim mFTPTotalUploaded 	As Int
	Dim mFTPError				As Boolean
End Sub

Sub Globals
	Dim btnSincronizar 	As Button
	
	Dim lblDownload 	As Label
	Dim lblUpload 		As Label
	Dim edtDownloadLog 	As EditText
	Dim edtUploadLog 	As EditText
	
	Dim lstVendas		As List

End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("frmSincronizacao")
	AjustaControles
	If (FirstTime) Then 
		mFTP.Initialize("FTP", Geral.FTP_HOST, 21, Geral.FTP_USUARIO, Geral.FTP_SENHA)
		mFTP.PassiveMode = Geral.FTP_MODO_PASSIVO
	End If
	lstVendas.Initialize()
	CarregaListaVendas
End Sub

Sub Activity_Resume
	mFTP.CloseNow
	mFTP.Initialize("FTP", Geral.FTP_HOST, 21, Geral.FTP_USUARIO, Geral.FTP_SENHA)
	mFTP.PassiveMode = Geral.FTP_MODO_PASSIVO
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	Activity.Finish
End Sub

Sub btnSincronizar_Click
	If Not(Geral.CarregaSetup()) Then  
		Geral.Erro("Configure o SETUP corretamente")
		Return
	End If
	If Not (Geral.TestaInternet()) Then 
		Geral.Erro("Sua INTERNET não está ativa. Por favor ative antes de sincronizar.")
		Return
	End If
	edtDownloadLog.Text = ""
	mFTPTotalDownloaded = 0
	mFTPTotalUploaded   = 0
	
	Download(Geral.arquivos_necessarios.Get(mFTPTotalDownloaded))
End Sub

Sub Download(sFile As String) 
	'Geral.Aviso("FTP: " & sFile)
	mFTP.DownloadFile(Geral.FTP_PASTA & "/" & sFile, _
						  True, _
						  Geral.FILE_PATH, _
						  sFile)
End Sub

Sub Upload(sFile As String)
	mFTPError		= False
	mFTP.UploadFile(Geral.FILE_PATH, sFile, False, Geral.FTP_PASTA & "/" & sFile)
End Sub


Sub FTP_DownloadProgress (ServerPath As String, TotalDownloaded As Long, Total As Long)
	Dim s As String
	s = "Baixando " & Geral.ExtractFileName(ServerPath) & ">" & Round(TotalDownloaded / 1000) & "KB"
	If Total > 0 Then s = s & " de " & Round(Total / 1000) & "KB"
	lblDownload.Text = s
	Sleep(0)
End Sub

Sub FTP_DownloadCompleted(ServerPath As String, Success As Boolean)
	If (Success) Then 
		mFTPTotalDownloaded = mFTPTotalDownloaded + 1
		edtDownloadLog.Text = edtDownloadLog.Text & ServerPath & CRLF
		If (mFTPTotalDownloaded >= Geral.arquivos_necessarios.Size) Then
			lblDownload.Text = "Download"
			If lstVendas.Size > 0 Then
				Upload(lstVendas.Get(mFTPTotalUploaded))
			Else
				Geral.Aviso("Download OK")	
			End If
		Else
			Download(Geral.arquivos_necessarios.Get(mFTPTotalDownloaded))
		End If
	Else
		Geral.Erro("Erro ao baixar:" & ServerPath & CRLF & LastException.Message)
		lblDownload.Text = "Download"
	End If
End Sub

Sub FTP_UploadCompleted (ServerPath As String, Success As Boolean)
	If (Success) Then 
		mFTPTotalUploaded = mFTPTotalUploaded + 1
		File.Delete(Geral.FILE_PATH, lstVendas.Get(0))
		CarregaListaVendas
		If (lstVendas.Size = 0) Then
			lblUpload.Text = "Upload" 
			Geral.Aviso("Upload OK e Download OK")
		Else
			Upload(lstVendas.Get(0))
		End If
	Else
		mFTPError = True
		Geral.Erro("Erro ao enviar:" & ServerPath & CRLF & LastException.Message)
		lblUpload.Text = "Upload"
	End If
End Sub

Sub FTP_UploadProgress (ServerPath As String, TotalDownloaded As Long, Total As Long)
	Dim s As String
	s = "Enviando " & Geral.ExtractFileName(ServerPath) & ">" & Round(TotalDownloaded / 1000) & "KB"
	If Total > 0 Then s = s & " de " & Round(Total / 1000) & "KB"
	lblUpload.Text = s
	Sleep(0)
End Sub

Sub CarregaListaVendas
	Dim lstAux As List
	Dim Linha As String
	
	lstAux = File.ListFiles(Geral.FILE_PATH)
	edtUploadLog.Text = ""
	If (lstAux <> Null) Then
		lstVendas.Clear
		For i = 0 To lstAux.Size - 1 
			Linha = lstAux.Get(i)
			If (Linha.ToLowerCase.StartsWith("venda")) Then 
				lstVendas.Add(Linha)
				edtUploadLog.Text = edtUploadLog.text & Linha & CRLF 
			End If
		Next
	End If
End Sub

Sub AjustaControles
	Dim W As Int: W = Geral.DefaultWidth(Activity.Width)
	Dim L As Int: L = Geral.DefaultLeft()
	
	lblDownload.Top      = 0
	lblDownload.Width  	= W
	lblDownload.Left     = L
	
	edtDownloadLog.Top   = lblDownload.Top + lblDownload.Height + 2
	edtDownloadLog.Width = W
	edtDownloadLog.Left  = L
	
	lblUpload.Top		 = edtDownloadLog.Top + edtDownloadLog.Height + 2
	lblUpload.Width      = W
	
	edtUploadLog.Top     = lblUpload.Top + lblUpload.Height + 2
	edtUploadLog.Height  = Activity.Height - edtUploadLog.Top - btnSincronizar.Height - 2
	edtUploadLog.Width   = W
	edtUploadLog.Left    = L
	
	btnSincronizar.Top   = Activity.Height - btnSincronizar.Height
	btnSincronizar.Left  = L
	btnSincronizar.Width = W
	
	
End Sub